"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var slate_1 = require("slate");
var slate_kit_plugins_utils_1 = require("@vericus/slate-kit-plugins-utils");
var tinycolor2_1 = tslib_1.__importDefault(require("tinycolor2"));
function createChanges(opt) {
    var defaultColor = opt.defaultColor, data = opt.data, type = opt.type;
    return {
        changeColor: function (change, color) {
            var _a, _b;
            var value = change.value;
            var selection = value.selection, document = value.document;
            if (slate_kit_plugins_utils_1.hasMark(value, type)) {
                if (tinycolor2_1.default(color).toName() === defaultColor) {
                    if (selection.isCollapsed) {
                        slate_kit_plugins_utils_1.removeCollapsedMark(value, change, type);
                    }
                    else {
                        slate_kit_plugins_utils_1.removeExpandedMark(document, selection, change, type);
                    }
                }
                else {
                    var newMark = new slate_1.Mark({
                        type: type,
                        data: slate_1.Data.create((_a = {},
                            _a[data] = color,
                            _a))
                    });
                    if (selection.isCollapsed) {
                        slate_kit_plugins_utils_1.removeCollapsedMark(value, change, type);
                        change.focus();
                        change.addMark(newMark);
                    }
                    else {
                        slate_kit_plugins_utils_1.removeExpandedMark(document, selection, change, type);
                        change.addMarkAtRange(selection, newMark);
                    }
                }
            }
            else if (tinycolor2_1.default(color).toName() !== defaultColor) {
                var mark = new slate_1.Mark({
                    type: type,
                    data: slate_1.Data.create((_b = {},
                        _b[data] = color,
                        _b))
                });
                if (selection.isCollapsed) {
                    change.addMark(mark);
                }
                else {
                    slate_kit_plugins_utils_1.removeExpandedMark(document, selection, change, type);
                    change.addMarkAtRange(selection, mark);
                }
            }
            change.focus();
            return change;
        }
    };
}
exports.default = createChanges;
//# sourceMappingURL=index.js.map