"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createUtils(opts) {
    var defaultColor = opts.defaultColor, data = opts.data, type = opts.type;
    return {
        currentColor: function (value) {
            if (value.selection && value.selection.isFocused && value.activeMarks) {
                var activeColorMarks = value.activeMarks
                    .filter(function (mark) { return !!(mark && mark.type === type); })
                    .reduce(function (colors, mark) {
                    if (mark && mark.data.get(data)) {
                        return colors.concat([mark.data.get(data)]);
                    }
                    return colors;
                }, []);
                var uniqueColorMarks = Array.from(new Set(activeColorMarks)).slice();
                if (uniqueColorMarks.length !== 0) {
                    return uniqueColorMarks[0];
                }
            }
            return defaultColor;
        }
    };
}
exports.default = createUtils;
//# sourceMappingURL=index.js.map